[Python] 파이썬 함수가 예외를 throw하는 것을 어떻게 테스트합니까?


Answers

Python 2.7 이후 컨텍스트 관리자를 사용하여 실제 Exception 객체를 가져올 수 있습니다.

import unittest

def broken_function():
    raise Exception('This is broken')

class MyTestCase(unittest.TestCase):
    def test(self):
        with self.assertRaises(Exception) as context:
            broken_function()

        self.assertTrue('This is broken' in context.exception)

if __name__ == '__main__':
    unittest.main()

http://docs.python.org/dev/library/unittest.html#unittest.TestCase.assertRaises

파이썬 3.5 에서는 str 에서 context.exception 을 래핑해야합니다. 그렇지 않으면 TypeError

self.assertTrue('This is broken' in str(context.exception))
Question

함수가 예상 된 예외를 throw하지 않는 경우에만 실패하는 unittest를 작성하는 방법은 무엇입니까?




자신 만의 contextmanager 를 구축하여 예외가 발생했는지 확인할 수 있습니다.

import contextlib

@contextlib.contextmanager
def raises(exception):
    try:
        yield 
    except exception as e:
        assert True
    else:
        assert False

그리고 다음과 같이 raises 를 사용할 수 있습니다.

with raises(Exception):
    print "Hola"  # Calls assert False

with raises(Exception):
    raise Exception  # Calls assert True

pytest 를 사용하고 pytest , 이미 구현되어 있습니다. pytest.raises(Exception) 할 수 있습니다.

예:

def test_div_zero():
    with pytest.raises(ZeroDivisionError):
        1/0

결과 :

pigueiras@pigueiras$ py.test
================= test session starts =================
platform linux2 -- Python 2.6.6 -- py-1.4.20 -- pytest-2.5.2 -- /usr/bin/python
collected 1 items 

tests/test_div_zero.py:6: test_div_zero PASSED



from : http://www.lengrand.fr/2011/12/pythonunittest-assertraises-raises-error/

먼저 dum_function.py 파일에있는 해당하는 (still dum : p) 함수가 있습니다.

def square_value(a):
   """
   Returns the square value of a.
   """
   try:
       out = a*a
   except TypeError:
       raise TypeError("Input should be a string:")

   return out

수행 할 테스트는 다음과 같습니다 (이 테스트 만 삽입 됨).

import dum_function as df # import function module
import unittest
class Test(unittest.TestCase):
   """
      The class inherits from unittest
      """
   def setUp(self):
       """
       This method is called before each test
       """
       self.false_int = "A"

   def tearDown(self):
       """
       This method is called after each test
       """
       pass
      #---
         ## TESTS
   def test_square_value(self):
       # assertRaises(excClass, callableObj) prototype
       self.assertRaises(TypeError, df.square_value(self.false_int))

   if __name__ == "__main__":
       unittest.main()

우리는 이제 우리의 기능을 시험 할 준비가되었습니다! 테스트를 실행하려고 할 때 발생하는 상황은 다음과 같습니다.

======================================================================
ERROR: test_square_value (__main__.Test)
----------------------------------------------------------------------
Traceback (most recent call last):
  File "test_dum_function.py", line 22, in test_square_value
    self.assertRaises(TypeError, df.square_value(self.false_int))
  File "/home/jlengrand/Desktop/function.py", line 8, in square_value
    raise TypeError("Input should be a string:")
TypeError: Input should be a string:

----------------------------------------------------------------------
Ran 1 test in 0.000s

FAILED (errors=1)

TypeError가 발생하여 테스트 실패가 발생합니다. 문제는 이것이 우리가 원하는 행동과 정확히 일치한다는 것입니다.

이 오류를 피하려면 테스트 호출에서 lambda를 사용하여 함수를 실행하기 만하면됩니다.

self.assertRaises(TypeError, lambda: df.square_value(self.false_int))

최종 출력 :

----------------------------------------------------------------------
Ran 1 test in 0.000s

OK

완벽 해!

... 나를 위해서도 완벽합니다 !!

Thansk a lot Julien Lengrand-Lambert




파이썬 함수가 예외를 throw하는 것을 어떻게 테스트합니까?

함수가 예상 된 예외를 throw하지 않는 경우에만 실패하는 테스트를 작성하는 방법은 무엇입니까?

짧은 답변:

컨텍스트 관리자로 self.assertRaises 메서드를 사용하십시오.

    def test_1_cannot_add_int_and_str(self):
        with self.assertRaises(TypeError):
            1 + '1'

데모

모범 사례 접근법은 Python 셸에서 매우 쉽게 보여줍니다.

unittest 라이브러리

파이썬 2.7 또는 3 :

import unittest

Python 2.6에서는 unittest 라는 2.7의 unittest 라이브러리의 백 포트를 설치할 수 있으며 unittest 로 별칭을 지정할 수 있습니다.

import unittest2 as unittest

예제 테스트

이제 Python 셸에 다음 Python 유형 안전 테스트를 붙여 넣으십시오.

class MyTestCase(unittest.TestCase):
    def test_1_cannot_add_int_and_str(self):
        with self.assertRaises(TypeError):
            1 + '1'
    def test_2_cannot_add_int_and_str(self):
        import operator
        self.assertRaises(TypeError, operator.add, 1, '1')

테스트는 컨텍스트 관리자로 assertRaises 를 사용합니다.이 컨텍스트 관리자는 기록되는 동안 오류가 제대로 캐치되고 정리되도록합니다.

컨텍스트 관리자 없이 테스트를 작성할 수도 있습니다 (테스트 2 참조). 첫 번째 인수는 올릴 오류 유형, 두 번째 인수, 테스트중인 함수, 나머지 args 및 키워드 args는 해당 함수에 전달됩니다.

컨텍스트 관리자를 사용하는 것이 훨씬 간단하고 읽기 쉽고 유지 관리가 가능하다고 생각합니다.

테스트 실행하기

테스트를 실행하려면 다음과 같이하십시오.

unittest.main(exit=False)

파이썬 2.6에서는 다음과 같은 것들이 필요할 것이다.

unittest.TextTestRunner().run(unittest.TestLoader().loadTestsFromTestCase(MyTestCase))

그리고 터미널은 다음을 출력해야합니다 :

..
----------------------------------------------------------------------
Ran 2 tests in 0.007s

OK
<unittest2.runner.TextTestResult run=2 errors=0 failures=0>

그리고 우리가 예상 한대로 TypeError 1'1' 을 추가하려고 시도합니다.

좀 더 자세한 결과를 얻으려면 다음을 시도하십시오.

unittest.TextTestRunner(verbosity=2).run(unittest.TestLoader().loadTestsFromTestCase(MyTestCase))



unittest 모듈의 assertRaises 메소드를 살펴보십시오.